Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/BoostSerializationSupport.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/BoostSerializationSupport.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/BoostSerializationSupport.cpp	(revision 523)
@@ -53,5 +53,5 @@
 	MessageBox( NULL, msg, "XMLシリアライズの例外", MB_OK );
 }
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadXml( istream& ifs, bool isShowExceptionMessage )
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadXml( std::istream& ifs, bool isShowExceptionMessage )
 {
 	bool isSuccessful = false;
@@ -86,5 +86,5 @@
 	return true;
 }
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteXml( ostream& ofs, bool isShowExceptionMessage ) const
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteXml( std::ostream& ofs, bool isShowExceptionMessage ) const
 {
 	bool isSuccessful = false;
@@ -119,5 +119,5 @@
 	return true;
 }
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadXml( const string &xmlFilePath, bool isShowExceptionMessage )
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadXml( const std::string &xmlFilePath, bool isShowExceptionMessage )
 {
 	// 入力アーカイブの作成
@@ -131,5 +131,5 @@
 	return result;
 }
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteXml( const string &xmlFilePath, bool isShowExceptionMessage ) const
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteXml( const std::string &xmlFilePath, bool isShowExceptionMessage ) const
 {
 	// 出力アーカイブの作成
@@ -201,8 +201,8 @@
 }
 
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadBinaryFile( const string &filePath, bool isShowExceptionMessage )
-{
-	// 入力アーカイブの作成
-	std::ifstream ifs( filePath.c_str(), ios::in | ios::binary );
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadBinaryFile( const std::string &filePath, bool isShowExceptionMessage )
+{
+	// 入力アーカイブの作成
+	std::ifstream ifs( filePath.c_str(), std::ios::in | std::ios::binary );
 
 	bool isSuccessful = false;
@@ -239,8 +239,8 @@
 	return true;
 }
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteBinaryFile( const string &filePath, bool isShowExceptionMessage ) const
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteBinaryFile( const std::string &filePath, bool isShowExceptionMessage ) const
 {
 	// 出力アーカイブの作成
-	std::ofstream ofs( filePath.c_str(), ios::out | ios::binary );
+	std::ofstream ofs( filePath.c_str(), std::ios::out | std::ios::binary );
 
 	bool isSuccessful = false;
@@ -283,5 +283,5 @@
 
 	// 入力アーカイブの作成
-	std::istringstream iss( binaryString, ios::in | ios::binary );
+	std::istringstream iss( binaryString, std::ios::in | std::ios::binary );
 
 	try{
@@ -306,5 +306,5 @@
 {
 	// 出力アーカイブの作成
-	std::ostringstream oss( "", ios::out | ios::binary );
+	std::ostringstream oss( "", std::ios::out | std::ios::binary );
 
 	bool isSuccessful = false;
@@ -332,5 +332,5 @@
 /*
 ビルドに時間がかかるので外しておく
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadText( const string &filePath, bool isShowExceptionMessage )
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::ReadText( const std::string &filePath, bool isShowExceptionMessage )
 {
 	// 入力アーカイブの作成
@@ -370,5 +370,5 @@
 	return true;
 }
-template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteText( const string &filePath, bool isShowExceptionMessage ) const
+template<class T_xml_schema> bool BoostSerializationSupport<T_xml_schema>::WriteText( const std::string &filePath, bool isShowExceptionMessage ) const
 {
 	// 出力アーカイブの作成
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Class.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Class.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Class.cpp	(revision 523)
@@ -1099,5 +1099,5 @@
 }
 
-const CClass *Classes::Find( const NamespaceScopes &namespaceScopes, const string &name ) const
+const CClass *Classes::Find( const NamespaceScopes &namespaceScopes, const std::string &name ) const
 {
 	if( namespaceScopes.size() == 0 && name == "Object" ){
@@ -1145,5 +1145,5 @@
 	return NULL;
 }
-const CClass *Classes::Find( const string &fullName ) const
+const CClass *Classes::Find( const std::string &fullName ) const
 {
 	char AreaName[VN_SIZE] = "";		//オブジェクト変数
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Compiler.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Compiler.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Compiler.cpp	(revision 523)
@@ -15,5 +15,5 @@
 }
 
-bool Compiler::StringToType( const string &typeName, Type &type ){
+bool Compiler::StringToType( const std::string &typeName, Type &type ){
 	type.SetIndex( -1 );
 
@@ -85,5 +85,5 @@
 		}
 
-		const string &nextTypeName = typeName.substr( 1 );
+		const std::string &nextTypeName = typeName.substr( 1 );
 
 		if( !StringToType( nextTypeName, type ) ){
@@ -166,5 +166,5 @@
 }
 
-const string Compiler::TypeToString( const Type &type )
+const std::string Compiler::TypeToString( const Type &type )
 {
 	if( PTR_LEVEL( type.GetBasicType() ) ){
@@ -173,5 +173,5 @@
 		tempType.PtrLevelDown();
 
-		return (string)"*" + TypeToString( tempType );
+		return (std::string)"*" + TypeToString( tempType );
 	}
 	else if( type.IsObject() || type.IsStruct() ){
@@ -202,5 +202,5 @@
 		if( lpszTypeName )
 		{
-			return (const string)lpszTypeName;
+			return (const std::string)lpszTypeName;
 		}
 	}
@@ -208,4 +208,4 @@
 	compiler.errorMessenger.Output(1, NULL, cp);
 
-	return (string)"(null)";
+	return (std::string)"(null)";
 }
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Const.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Const.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Const.cpp	(revision 523)
@@ -49,5 +49,5 @@
 }
 
-void Consts::Add( const NamespaceScopes &namespaceScopes, const string &name , char *Expression)
+void Consts::Add( const NamespaceScopes &namespaceScopes, const std::string &name , char *Expression)
 {
 	_int64 i64data;
@@ -67,5 +67,5 @@
 	Put( newconst );
 }
-void Consts::Add(const NamespaceScopes &namespaceScopes, const string &name, int value){
+void Consts::Add(const NamespaceScopes &namespaceScopes, const std::string &name, int value){
 	CConst *newconst = new CConst( namespaceScopes, name, value);
 
@@ -74,5 +74,5 @@
 }
 
-CConst *Consts::GetObjectPtr( const string &name ){
+CConst *Consts::GetObjectPtr( const std::string &name ){
 	char ObjName[VN_SIZE];		//オブジェクト変数
 	char NestMember[VN_SIZE];	//入れ子メンバ
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Delegate.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Delegate.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Delegate.cpp	(revision 523)
@@ -214,5 +214,5 @@
 			values.insert( std::map<std::string,std::string>::value_type(
 				"#call_method_begin#",
-				(string)"Function Call(" + dg.paramStr + ") As " + dg.returnTypeName
+				(std::string)"Function Call(" + dg.paramStr + ") As " + dg.returnTypeName
 			) );
 
@@ -228,5 +228,5 @@
 			values.insert( std::map<std::string,std::string>::value_type(
 				"#call_method_begin#",
-				(string)"Sub Call(" + dg.paramStr + ")"
+				(std::string)"Sub Call(" + dg.paramStr + ")"
 			) );
 
@@ -244,5 +244,5 @@
 	}
 /*
-	ofstream ofs( ( Jenga::Common::Environment::GetAppDir() + "\\generated_delegate_code.log" ).c_str() );
+	std::ofstream ofs( ( Jenga::Common::Environment::GetAppDir() + "\\generated_delegate_code.log" ).c_str() );
 	ofs << destSource;
 	ofs.close();
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Enum.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Enum.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Enum.cpp	(revision 523)
@@ -170,5 +170,5 @@
 	BOOST_FOREACH( const EnumInfo &enumInfo, thisEnumInfoCollection )
 	{
-		BOOST_FOREACH( const string &namespaceStr, enumInfo.GetNamespaceScopes() ){
+		BOOST_FOREACH( const std::string &namespaceStr, enumInfo.GetNamespaceScopes() ){
 			sprintf(buffer+length,"Namespace %s\n",namespaceStr.c_str());
 			length+=lstrlen(buffer+length);
@@ -214,5 +214,5 @@
 		length+=lstrlen(buffer+length);
 
-		BOOST_FOREACH( const string &namespaceStr, enumInfo.GetNamespaceScopes() ){
+		BOOST_FOREACH( const std::string &namespaceStr, enumInfo.GetNamespaceScopes() ){
 			lstrcpy( buffer+length, "End Namespace\n" );
 			length+=lstrlen(buffer+length);
@@ -230,5 +230,5 @@
 	// ログを生成
 	Jenga::Common::Logger logger( Jenga::Common::Environment::GetAppDir() + "\\enum_generated.log", false );
-	logger << buffer << endl;
+	logger << buffer << std::endl;
 #endif
 
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Messenger.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Messenger.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Messenger.cpp	(revision 523)
@@ -25,5 +25,5 @@
 
 	// 標準出力
-	std::cout << message << endl;
+	std::cout << message << std::endl;
 }
 int Messenger::GetNextErrorLine()
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Method.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Method.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Method.cpp	(revision 523)
@@ -103,5 +103,5 @@
 	return false;
 }
-void Methods::Enum( const char *methodName, vector<const UserProc *> &subs ) const
+void Methods::Enum( const char *methodName, std::vector<const UserProc *> &subs ) const
 {
 	//オブジェクトのメンバ関数の場合
@@ -114,5 +114,5 @@
 	}
 }
-void Methods::Enum( BYTE idOperatorCalc, vector<const UserProc *> &subs ) const
+void Methods::Enum( BYTE idOperatorCalc, std::vector<const UserProc *> &subs ) const
 {
 	//オブジェクトのメンバ関数の場合
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/ObjectModule.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/ObjectModule.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/ObjectModule.cpp	(revision 523)
@@ -48,4 +48,7 @@
 #include <boost/serialization/version.hpp>
 #include <boost/serialization/is_abstract.hpp>
+#include <boost/serialization/serialization.hpp>
+#include <boost/serialization/nvp.hpp>
+#include <boost/serialization/export.hpp>
 
 #include <jenga/include/jenga.h>
@@ -113,5 +116,5 @@
 		boost::archive::xml_iarchive ia(ifs);
 #else
-		std::ifstream ifs( filePath.c_str(), ios::in | ios::binary );
+		std::ifstream ifs( filePath.c_str(), std::ios::in | std::ios::binary );
 		boost::archive::binary_iarchive ia(ifs);
 #endif
@@ -146,5 +149,5 @@
 		boost::archive::xml_oarchive oa(ofs);
 #else
-		std::ofstream ofs( filePath.c_str(), ios::out | ios::binary );
+		std::ofstream ofs( filePath.c_str(), std::ios::out | std::ios::binary );
 		boost::archive::binary_oarchive oa(ofs);
 #endif
@@ -181,5 +184,5 @@
 		boost::archive::xml_iarchive ia(iss);
 #else
-		std::istringstream iss( str, ios::in | ios::binary );
+		std::istringstream iss( str, std::ios::in | std::ios::binary );
 		boost::archive::binary_iarchive ia(iss);
 #endif
@@ -215,5 +218,5 @@
 		boost::archive::xml_oarchive oa(oss);
 #else
-		std::ostringstream oss( "", ios::out | ios::binary );
+		std::ostringstream oss( "", std::ios::out | std::ios::binary );
 		boost::archive::binary_oarchive oa(oss);
 #endif
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Procedure.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Procedure.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Procedure.cpp	(revision 523)
@@ -458,5 +458,5 @@
 	if( this->pParentClass && isStatic == false ){
 		//オブジェクトメンバの場合は、第一パラメータを_System_LocalThis引き渡し用として利用
-		string name = "_System_LocalThis";
+		std::string name = "_System_LocalThis";
 		Type type( DEF_PTR_VOID );
 		this->realParams.push_back( new Parameter( name, type ) );
@@ -467,5 +467,5 @@
 		//※第一パラメータ（Thisポインタありの場合は第二パラメータ）を戻り値用の参照宣言にする
 
-		string name = this->GetName();
+		std::string name = this->GetName();
 		if(name[0]==1&&name[1]==ESC_OPERATOR){
 			name="_System_ReturnValue";
@@ -1004,8 +1004,8 @@
 }
 
-int ProcPointers::Add( const string &typeExpression )
+int ProcPointers::Add( const std::string &typeExpression )
 {
 	DWORD dwProcType = (DWORD)typeExpression[2];
-	const string &paramStr = typeExpression.substr( 3 );
+	const std::string &paramStr = typeExpression.substr( 3 );
 
 	Procedure::Kind kind = Procedure::Sub;
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Source.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Source.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Source.cpp	(revision 523)
@@ -1,9 +1,9 @@
 #include "stdafx.h"
 
-const string BasicSource::generateDirectiveName = "#generate";
+const std::string BasicSource::generateDirectiveName = "#generate";
 
 
 class CDefine{
-	vector<string> names;
+	std::vector<std::string> names;
 public:
 	CDefine( int majorVer );
@@ -138,6 +138,6 @@
 }
 BOOL CDefine::undef(char *name){
-	vector<string>::iterator i = names.begin();
-	BOOST_FOREACH( const string &temp, names ){
+	std::vector<std::string>::iterator i = names.begin();
+	BOOST_FOREACH( const std::string &temp, names ){
 		if( temp == name ){
 			names.erase( i );
@@ -152,5 +152,5 @@
 
 	//重複チェック
-	BOOST_FOREACH( const string &temp, names ){
+	BOOST_FOREACH( const std::string &temp, names ){
 		if( temp == name ){
 			return 1;
@@ -390,5 +390,5 @@
 
 
-bool Text::ReadFile( const string &filePath ){
+bool Text::ReadFile( const std::string &filePath ){
 	//ファイルオープン
 	HANDLE hFile=CreateFile(filePath.c_str(),GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
@@ -519,5 +519,5 @@
 }
 
-bool BasicSource::ReadFile_InIncludeDirective( const string &filePath ){
+bool BasicSource::ReadFile_InIncludeDirective( const std::string &filePath ){
 	if( !Text::ReadFile( filePath ) ){
 		return false;
@@ -854,5 +854,5 @@
 }
 
-bool BasicSource::ReadFile( const string &filePath ){
+bool BasicSource::ReadFile( const std::string &filePath ){
 	if( !Text::ReadFile( filePath ) ){
 		return false;
@@ -902,5 +902,5 @@
 }
 
-bool BasicSource::Generate( const string &genName, const char *genBuffer ){
+bool BasicSource::Generate( const std::string &genName, const char *genBuffer ){
 	const int genBufferLength = lstrlen( genBuffer );
 
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Type.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Type.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Type.cpp	(revision 523)
@@ -2,6 +2,4 @@
 
 #include <Class.h>
-
-using namespace std;
 
 const int Type::basicTypeList[] = {
@@ -27,5 +25,5 @@
 };
 
-const string Type::basicTypeNameList[] = {
+const std::string Type::basicTypeNameList[] = {
 	"Byte",
 	"SByte",
@@ -53,5 +51,5 @@
 }
 
-bool Type::StringToBasicType( const string &typeName, int &basicType ){
+bool Type::StringToBasicType( const std::string &typeName, int &basicType ){
 	for( int i=0; ; i++ ){
 		if( basicTypeList[i] == DEF_NON ){
@@ -615,5 +613,5 @@
 
 
-const string BlittableType::GetCreateStaticMethodFullName() const
+const std::string BlittableType::GetCreateStaticMethodFullName() const
 {
 	return pClass->GetNamespaceScopes().ToString() + "." + pClass->GetName() + "._Create";
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/TypeDef.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/TypeDef.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/TypeDef.cpp	(revision 523)
@@ -4,5 +4,5 @@
 #include <Compiler.h>
 
-TypeDef::TypeDef( const NamespaceScopes &namespaceScopes, const string &name, const string &baseName, int nowLine )
+TypeDef::TypeDef( const NamespaceScopes &namespaceScopes, const std::string &name, const std::string &baseName, int nowLine )
 	: Symbol( namespaceScopes, name )
 	, baseName( baseName )
@@ -14,5 +14,5 @@
 }
 /*
-bool TypeDef::IsEqualSymbol( const NamespaceScopes &namespaceScopes, const string &name ) const
+bool TypeDef::IsEqualSymbol( const NamespaceScopes &namespaceScopes, const std::string &name ) const
 {
 	if( GetName() != name ){
@@ -21,5 +21,5 @@
 	return compiler.GetNamespaceSupporter().IsSameAreaNamespace( this->namespaceScopes, namespaceScopes );
 }
-bool TypeDef::IsEqualSymbol( const string &fullName ) const
+bool TypeDef::IsEqualSymbol( const std::string &fullName ) const
 {
 	char AreaName[VN_SIZE] = "";		//オブジェクト変数
@@ -52,9 +52,9 @@
 TypeDefCollection::~TypeDefCollection(){
 }
-void TypeDefCollection::Add( const NamespaceScopes &namespaceScopes, const string &name, const string &baseName, int nowLine ){
+void TypeDefCollection::Add( const NamespaceScopes &namespaceScopes, const std::string &name, const std::string &baseName, int nowLine ){
 	TypeDef typeDef( namespaceScopes, name, baseName, nowLine );
 	this->push_back( typeDef );
 }
-int TypeDefCollection::GetIndex( const NamespaceScopes &namespaceScopes, const string &name ) const{
+int TypeDefCollection::GetIndex( const NamespaceScopes &namespaceScopes, const std::string &name ) const{
 	int max = (int)(*this).size();
 	for( int i=0; i<max; i++ ){
@@ -65,5 +65,5 @@
 	return -1;
 }
-int TypeDefCollection::GetIndex( const string &fullName ) const{
+int TypeDefCollection::GetIndex( const std::string &fullName ) const{
 	char AreaName[VN_SIZE] = "";		//オブジェクト変数
 	char NestName[VN_SIZE] = "";		//入れ子メンバ
@@ -73,5 +73,5 @@
 }
 
-void TypeDefCollection::Add( const NamespaceScopes &namespaceScopes, const string &expression, int nowLine ){
+void TypeDefCollection::Add( const NamespaceScopes &namespaceScopes, const std::string &expression, int nowLine ){
 	int i;
 	char temporary[VN_SIZE];
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Variable.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Variable.cpp	(revision 522)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Variable.cpp	(revision 523)
@@ -4,5 +4,5 @@
 #include <Variable.h>
 
-Variable::Variable( const string &name, const Type &type, bool isConst, bool isRef, const std::string &paramStrForConstructor, bool hasInitData )
+Variable::Variable( const std::string &name, const Type &type, bool isConst, bool isRef, const std::string &paramStrForConstructor, bool hasInitData )
 	: Symbol( ActiveBasic::Compiler::LexicalAnalyzer::FullNameToSymbol( name ) )
 	, type( type )
@@ -15,5 +15,5 @@
 {
 }
-Variable::Variable( const NamespaceScopes &namespaceScopes, const string &name, const Type &type, bool isConst, bool isRef, const std::string &paramStrForConstructor, bool hasInitData )
+Variable::Variable( const NamespaceScopes &namespaceScopes, const std::string &name, const Type &type, bool isConst, bool isRef, const std::string &paramStrForConstructor, bool hasInitData )
 	: Symbol( namespaceScopes, name )
 	, type( type )