Index: trunk/ab5.0/ablib/src/api_wininet.sbp
===================================================================
--- trunk/ab5.0/ablib/src/api_wininet.sbp	(revision 537)
+++ trunk/ab5.0/ablib/src/api_wininet.sbp	(revision 540)
@@ -9,4 +9,6 @@
 Const _FuncName_FtpFindFirstFile = "FtpFindFirstFileW"
 Const _FuncName_InternetFindNextFile = "InternetFindNextFileW"
+Const _FuncName_InternetOpenUrl = "InternetOpenUrlW"
+Const _FuncName_HttpQueryInfo = "HttpQueryInfoW"
 #else
 Const _FuncName_InternetOpen = "InternetOpenA"
@@ -17,4 +19,6 @@
 Const _FuncName_FtpFindFirstFile = "FtpFindFirstFileA"
 Const _FuncName_InternetFindNextFile = "InternetFindNextFileA"
+Const _FuncName_InternetOpenUrl = "InternetOpenUrlA"
+Const _FuncName_HttpQueryInfo = "HttpQueryInfoA"
 #endif
 
@@ -69,4 +73,73 @@
 Declare Function InternetCloseHandle Lib "wininet.dll" (hInternet As HINTERNET) As BOOL
 
+Declare Function InternetOpenUrl Lib "wininet.dll" Alias _FuncName_InternetOpenUrl (
+	hInternet As HINTERNET,
+	lpszUrl As LPCTSTR,
+	lpszHeaders As LPCTSTR,
+	dwHeadersLength As DWord,
+	dwFlags As DWord,
+	dwContext As DWORD_PTR ) As HINTERNET
+
+
+
+'----------------
+' HTTP
+'----------------
+
+Const HTTP_QUERY_MIME_VERSION                 = 0
+Const HTTP_QUERY_CONTENT_TYPE                 = 1
+Const HTTP_QUERY_CONTENT_TRANSFER_ENCODING    = 2
+Const HTTP_QUERY_CONTENT_ID                   = 3
+Const HTTP_QUERY_CONTENT_DESCRIPTION          = 4
+Const HTTP_QUERY_CONTENT_LENGTH               = 5
+Const HTTP_QUERY_CONTENT_LANGUAGE             = 6
+Const HTTP_QUERY_ALLOW                        = 7
+Const HTTP_QUERY_PUBLIC                       = 8
+Const HTTP_QUERY_DATE                         = 9
+Const HTTP_QUERY_EXPIRES                      = 10
+Const HTTP_QUERY_LAST_MODIFIED                = 11
+Const HTTP_QUERY_MESSAGE_ID                   = 12
+Const HTTP_QUERY_URI                          = 13
+Const HTTP_QUERY_DERIVED_FROM                 = 14
+Const HTTP_QUERY_COST                         = 15
+Const HTTP_QUERY_LINK                         = 16
+Const HTTP_QUERY_PRAGMA                       = 17
+Const HTTP_QUERY_VERSION                      = 18  ' special: part of status line
+Const HTTP_QUERY_STATUS_CODE                  = 19  ' special: part of status line
+Const HTTP_QUERY_STATUS_TEXT                  = 20  ' special: part of status line
+Const HTTP_QUERY_RAW_HEADERS                  = 21  ' special: all headers as ASCIIZ
+Const HTTP_QUERY_RAW_HEADERS_CRLF             = 22  ' special: all headers
+Const HTTP_QUERY_CONNECTION                   = 23
+Const HTTP_QUERY_ACCEPT                       = 24
+Const HTTP_QUERY_ACCEPT_CHARSET               = 25
+Const HTTP_QUERY_ACCEPT_ENCODING              = 26
+Const HTTP_QUERY_ACCEPT_LANGUAGE              = 27
+Const HTTP_QUERY_AUTHORIZATION                = 28
+Const HTTP_QUERY_CONTENT_ENCODING             = 29
+Const HTTP_QUERY_FORWARDED                    = 30
+Const HTTP_QUERY_FROM                         = 31
+Const HTTP_QUERY_IF_MODIFIED_SINCE            = 32
+Const HTTP_QUERY_LOCATION                     = 33
+Const HTTP_QUERY_ORIG_URI                     = 34
+Const HTTP_QUERY_REFERER                      = 35
+Const HTTP_QUERY_RETRY_AFTER                  = 36
+Const HTTP_QUERY_SERVER                       = 37
+Const HTTP_QUERY_TITLE                        = 38
+Const HTTP_QUERY_USER_AGENT                   = 39
+Const HTTP_QUERY_WWW_AUTHENTICATE             = 40
+Const HTTP_QUERY_PROXY_AUTHENTICATE           = 41
+Const HTTP_QUERY_ACCEPT_RANGES                = 42
+Const HTTP_QUERY_SET_COOKIE                   = 43
+Const HTTP_QUERY_COOKIE                       = 44
+Const HTTP_QUERY_REQUEST_METHOD               = 45  ' special: GET/POST etc.
+Const HTTP_QUERY_REFRESH                      = 46
+Const HTTP_QUERY_CONTENT_DISPOSITION          = 47
+
+Declare Function HttpQueryInfo Lib "wininet.dll" Alias _FuncName_HttpQueryInfo (
+	hRequest As HINTERNET,
+	dwInfoLevel As DWord,
+	lpBuffer As VoidPtr,
+	ByRef lpdwBufferLength As DWord,
+	ByRef lpdwIndex As DWord ) As BOOL
 
 